diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelSheep.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelSheep.java
index c47acc326..b93762537 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelSheep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelSheep.java
@@ -3,9 +3,12 @@ package net.minecraft.client.render.model;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobSheep;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelSheep extends ModelQuadruped
 {
+    boolean isEatingAnimPlaying;
+    float headBobTime;
 
     public ModelSheep()
     {
@@ -19,9 +22,9 @@ public class ModelSheep extends ModelQuadruped
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         float desiredRotateAngleX = headPitch / 57.29578F;
         float desiredRotateAngleY = headYaw / 57.29578F;
         // handles head rotation
@@ -54,40 +57,36 @@ public class ModelSheep extends ModelQuadruped
             head.xRot = desiredRotateAngleX;
             head.yRot = desiredRotateAngleY;
         }
-    }
 
-    @Override
-    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
-    {
-        MobSheep entitySheep = (MobSheep) mob;
-        head.y = 6F;
-        isEatingAnimPlaying = false;
-        if(entitySheep.getIsSheepEating())
-        {
-            headBobTime = entitySheep.prevTimeSheepEating + (entitySheep.timeSheepEating - entitySheep.prevTimeSheepEating) * partialTick;
-            isEatingAnimPlaying = true;
-
-            // Move head down
-            if (headBobTime < 5)
-            {
-                head.y = 6 + (10 / 5f) * (headBobTime + 1);
-            }
-            // Hold head down and bob
-            else if (headBobTime < 35)
+        if (mob != null) {
+            MobSheep entitySheep = (MobSheep) mob;
+            head.y = 6F;
+            isEatingAnimPlaying = false;
+            if(entitySheep.getIsSheepEating())
             {
-                head.y = 16 + MathHelper.sin((headBobTime * 0.05f) * 30.5f) / 3f;
+                headBobTime = entitySheep.prevTimeSheepEating + (entitySheep.timeSheepEating - entitySheep.prevTimeSheepEating) * partialTick;
+                isEatingAnimPlaying = true;
+
+                // Move head down
+                if (headBobTime < 5)
+                {
+                    head.y = 6 + (10 / 5f) * (headBobTime + 1);
+                }
+                // Hold head down and bob
+                else if (headBobTime < 35)
+                {
+                    head.y = 16 + MathHelper.sin((headBobTime * 0.05f) * 30.5f) / 3f;
+                }
+                // Bring head back up
+                else if (headBobTime < 40)
+                {
+                    head.y = 16f - ((10 / 5f) * (headBobTime - 34));
+                }
             }
-            // Bring head back up
-            else if (headBobTime < 40)
+            else
             {
-                head.y = 16f - ((10 / 5f) * (headBobTime - 34));
+                headBobTime = 0;
             }
         }
-        else
-        {
-            headBobTime = 0;
-        }
     }
-    boolean isEatingAnimPlaying;
-    float headBobTime;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
index d8650285d..18ab1b0e9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelSheepOverlay.java
@@ -4,11 +4,11 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobSheep;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class ModelSheepOverlay extends ModelSheep
 {
-    Mob sheep;
 
     public ModelSheepOverlay()
     {
@@ -16,25 +16,14 @@ public class ModelSheepOverlay extends ModelSheep
     }
 
     @Override
-    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        super.setLivingAnimations(mob, limbSwing, limbYaw, partialTick);
-        this.sheep = mob;
-        float brightness = sheep.getBrightness(limbSwing);
-        if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
-        int j = ((MobSheep)sheep).getFleeceColor().blockMeta;
-        GL11.glColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[j][0], brightness * MobSheep.FLEECE_COLOR_TABLE[j][1], brightness * MobSheep.FLEECE_COLOR_TABLE[j][2]);
-
-    }
-
-    @Override
-    public void onUnload(){
-        sheep = null;
-    }
-
-    @Override
-    public void render(float limbSwing, float limbYaw, float ticksExisted, float headYaw, float headPitch, float scale)
-    {
-        super.render(limbSwing, limbYaw, ticksExisted, headYaw, headPitch, scale);
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        if (mob != null) {
+            float brightness = mob.getBrightness(limbSwing);
+            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
+            int j = ((MobSheep)mob).getFleeceColor().blockMeta;
+            GL11.glColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[j][0], brightness * MobSheep.FLEECE_COLOR_TABLE[j][1], brightness * MobSheep.FLEECE_COLOR_TABLE[j][2]);
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelSlime.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelSlime.java
index 8904a454b..0523296a3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelSlime.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelSlime.java
@@ -1,7 +1,14 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
+
 public class ModelSlime extends ModelBase
 {
+    Cube slimeBodies;
+    Cube slimeRightEye;
+    Cube slimeLeftEye;
+    Cube slimeMouth;
 
     public ModelSlime(int i)
     {
@@ -21,14 +28,9 @@ public class ModelSlime extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
-    {
-    }
-
-    @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         slimeBodies.render(scale);
         if(slimeRightEye != null)
         {
@@ -37,9 +39,4 @@ public class ModelSlime extends ModelBase
             slimeMouth.render(scale);
         }
     }
-
-    Cube slimeBodies;
-    Cube slimeRightEye;
-    Cube slimeLeftEye;
-    Cube slimeMouth;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelSpider.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelSpider.java
index a24a75cc6..d79e9e19c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelSpider.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelSpider.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelSpider extends ModelBase
 {
@@ -56,9 +58,9 @@ public class ModelSpider extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         spiderHead.render(scale);
         spiderNeck.render(scale);
         spiderBody.render(scale);
@@ -73,7 +75,7 @@ public class ModelSpider extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         spiderHead.yRot = headYaw / 57.29578F;
         spiderHead.xRot = headPitch / 57.29578F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelSquid.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelSquid.java
index 5b9f4a919..e17a19cd1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelSquid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelSquid.java
@@ -1,7 +1,12 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
+import org.jetbrains.annotations.Nullable;
+
 public class ModelSquid extends ModelBase
 {
+    Cube squidBody;
+    Cube[] squidTentacles;
 
     public ModelSquid()
     {
@@ -27,7 +32,7 @@ public class ModelSquid extends ModelBase
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
         for(int i = 0; i < squidTentacles.length; i++)
         {
@@ -37,9 +42,9 @@ public class ModelSquid extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         squidBody.render(scale);
         for(int i = 0; i < squidTentacles.length; i++)
         {
@@ -47,7 +52,4 @@ public class ModelSquid extends ModelBase
         }
 
     }
-
-    Cube squidBody;
-    Cube squidTentacles[];
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelWolf.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelWolf.java
index 9158dc538..235e47e49 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelWolf.java
@@ -5,11 +5,24 @@ import net.minecraft.core.Global;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class ModelWolf extends ModelBase
 {
 
+    public Cube wolfHeadMain;
+    public Cube wolfBody;
+    public Cube wolfLeg1;
+    public Cube wolfLeg2;
+    public Cube wolfLeg3;
+    public Cube wolfLeg4;
+    Cube wolfRightEar;
+    Cube wolfLeftEar;
+    Cube wolfSnout;
+    Cube wolfTail;
+    Cube wolfMane;
+
     public ModelWolf(float expandAmount)
     {
         float f1 = 13.5F;
@@ -49,10 +62,9 @@ public class ModelWolf extends ModelBase
     }
 
     @Override
-    public void render(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
+    public void render(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        super.render(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+        setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
         wolfHeadMain.renderWithRotation(scale);
         wolfBody.render(scale);
         wolfLeg1.render(scale);
@@ -67,17 +79,18 @@ public class ModelWolf extends ModelBase
     }
 
     @Override
-    public void setLivingAnimations(Mob mob, float limbSwing, float limbYaw, float partialTick)
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick)
     {
-        MobWolf entitywolf = (MobWolf) mob;
-        if(entitywolf.isWolfAngry())
+        if (mob == null) return;
+        MobWolf wolf = (MobWolf) mob;
+        if(wolf.isWolfAngry())
         {
             wolfTail.yRot = 0.0F;
         } else
         {
             wolfTail.yRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         }
-        if(entitywolf.isWolfSitting())
+        if(wolf.isWolfSitting())
         {
             wolfMane.setRotationPoint(-1F, 16F, -3F);
             wolfMane.xRot = 1.256637F;
@@ -109,34 +122,30 @@ public class ModelWolf extends ModelBase
             wolfLeg3.xRot = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
             wolfLeg4.xRot = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
         }
-        float f3 = entitywolf.getInterestedAngle(partialTick) + entitywolf.getShakeAngle(partialTick, 0.0F);
+        float f3 = wolf.getInterestedAngle(partialTick) + wolf.getShakeAngle(partialTick, 0.0F);
         wolfHeadMain.zRot = f3;
         wolfRightEar.zRot = f3;
         wolfLeftEar.zRot = f3;
         wolfSnout.zRot = f3;
-        wolfMane.zRot = entitywolf.getShakeAngle(partialTick, -0.08F);
-        wolfBody.zRot = entitywolf.getShakeAngle(partialTick, -0.16F);
-        wolfTail.zRot = entitywolf.getShakeAngle(partialTick, -0.2F);
+        wolfMane.zRot = wolf.getShakeAngle(partialTick, -0.08F);
+        wolfBody.zRot = wolf.getShakeAngle(partialTick, -0.16F);
+        wolfTail.zRot = wolf.getShakeAngle(partialTick, -0.2F);
 
-        if(entitywolf.getWolfShaking())
+        if(wolf.getWolfShaking())
         {
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled()) {
-            	LightmapHelper.setLightmapCoord(entitywolf.getLightmapCoord(partialTick));
+            	LightmapHelper.setLightmapCoord(wolf.getLightmapCoord(partialTick));
             }else if(Global.accessor.isFullbrightEnabled()) {
-            	
+
             }else {
-            	brightness = entitywolf.getBrightness(partialTick);
+            	brightness = wolf.getBrightness(partialTick);
             }
-            float f4 = brightness * entitywolf.getShadingWhileShaking(partialTick);
+            float f4 = brightness * wolf.getShadingWhileShaking(partialTick);
             GL11.glColor3f(f4, f4, f4);
         }
-    }
 
-    @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale)
-    {
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
+
         wolfHeadMain.xRot = headPitch / 57.29578F;
         wolfHeadMain.yRot = headYaw / 57.29578F;
         wolfRightEar.yRot = wolfHeadMain.yRot;
@@ -147,16 +156,4 @@ public class ModelWolf extends ModelBase
         wolfSnout.xRot = wolfHeadMain.xRot;
         wolfTail.xRot = limbPitch;
     }
-
-    public Cube wolfHeadMain;
-    public Cube wolfBody;
-    public Cube wolfLeg1;
-    public Cube wolfLeg2;
-    public Cube wolfLeg3;
-    public Cube wolfLeg4;
-    Cube wolfRightEar;
-    Cube wolfLeftEar;
-    Cube wolfSnout;
-    Cube wolfTail;
-    Cube wolfMane;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelZombie.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelZombie.java
index 4af4cfe4f..75b7c6de8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelZombie.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelZombie.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.render.model;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 public class ModelZombie extends ModelBiped {
     public ModelZombie() {
@@ -11,61 +13,55 @@ public class ModelZombie extends ModelBiped {
         this.parts(var1, 0.0F);
     }
 
-    public void parts(float var1, float var2) {
+    public void parts(float expansion, float var2) {
         this.holdingLeftHand = false;
         this.holdingRightHand = false;
         this.sneaking = false;
         this.cloak = new Cube(0, 0);
-        this.cloak.addBox(-5.0F, 0.0F, -1.0F, 10, 16, 1, var1);
+        this.cloak.addBox(-5.0F, 0.0F, -1.0F, 10, 16, 1, expansion);
         this.ear = new Cube(24, 0);
-        this.ear.addBox(-4.0F, -7.0F, -1.0F, 7, 7, 1, var1);
+        this.ear.addBox(-4.0F, -7.0F, -1.0F, 7, 7, 1, expansion);
         this.head = new Cube(0, 0);
-        this.head.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1);
+        this.head.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, expansion);
         this.head.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
         this.hair = new Cube(32, 0);
-        this.hair.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1 + 0.5F);
+        this.hair.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, expansion + 0.5F);
         this.hair.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
         this.body = new Cube(16, 16);
-        this.body.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, var1);
+        this.body.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, expansion);
         this.body.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
         this.armRight = new Cube(40, 16);
-        this.armRight.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armRight.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, expansion);
         this.armRight.setRotationPoint(-5.0F, 2.0F + var2, 0.0F);
         this.armLeft = new Cube(40, 16);
         this.armLeft.mirror = true;
-        this.armLeft.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armLeft.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, expansion);
         this.armLeft.setRotationPoint(5.0F, 2.0F + var2, 0.0F);
         this.legRight = new Cube(0, 16);
-        this.legRight.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legRight.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion);
         this.legRight.setRotationPoint(-2.0F, 12.0F + var2, 0.0F);
         this.legLeft = new Cube(0, 16);
         this.legLeft.mirror = true;
-        this.legLeft.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legLeft.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, expansion);
         this.legLeft.setRotationPoint(2.0F, 12.0F + var2, 0.0F);
     }
 
     @Override
-    public void setupAnimation(float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale) {
-        super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
-        float var7 = MathHelper.sin(this.onGround * 3.1415927F);
-        float var8 = MathHelper.sin((1.0F - (1.0F - this.onGround) * (1.0F - this.onGround)) * 3.1415927F);
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        float var7 = MathHelper.sin(this.swingProgress * 3.1415927F);
+        float var8 = MathHelper.sin((1.0F - (1.0F - this.swingProgress) * (1.0F - this.swingProgress)) * 3.1415927F);
         this.armRight.zRot = 0.0F;
         this.armLeft.zRot = 0.0F;
         this.armRight.yRot = -(0.1F - var7 * 0.6F);
         this.armLeft.yRot = 0.1F - var7 * 0.6F;
         this.armRight.xRot = -1.5707964F;
         this.armLeft.xRot = -1.5707964F;
-        Cube var10000 = this.armRight;
-        var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
-        var10000 = this.armLeft;
-        var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
-        var10000 = this.armRight;
-        var10000.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        var10000 = this.armLeft;
-        var10000.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        var10000 = this.armRight;
-        var10000.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
-        var10000 = this.armLeft;
-        var10000.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        this.armRight.xRot -= var7 * 1.2F - var8 * 0.4F;
+        this.armLeft.xRot -= var7 * 1.2F - var8 * 0.4F;
+        this.armRight.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        this.armLeft.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        this.armRight.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        this.armLeft.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelZombiePigman.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelZombiePigman.java
new file mode 100644
index 000000000..9473fced1
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelZombiePigman.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.render.model;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
+
+public class ModelZombiePigman extends ModelPigman {
+    public ModelZombiePigman() {
+        this(0.0F);
+    }
+
+    public ModelZombiePigman(float var1) {
+        this.parts(var1, 0.0F);
+    }
+
+    public void parts(float var1, float var2) {
+        this.holdingLeftHand = false;
+        this.holdingRightHand = false;
+        this.sneaking = false;
+        this.cloak = new Cube(0, 0);
+        this.cloak.addBox(-5.0F, 0.0F, -1.0F, 10, 16, 1, var1);
+        this.ear = new Cube(24, 0);
+        this.ear.addBox(-4.0F, -7.0F, -1.0F, 7, 7, 1, var1);
+        this.head = new Cube(0, 0);
+        this.head.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1);
+        this.head.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.hair = new Cube(32, 0);
+        this.hair.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, var1 + 0.5F);
+        this.hair.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.body = new Cube(16, 16);
+        this.body.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, var1);
+        this.body.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
+        this.armRight = new Cube(40, 16);
+        this.armRight.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armRight.setRotationPoint(-5.0F, 2.0F + var2, 0.0F);
+        this.armLeft = new Cube(40, 16);
+        this.armLeft.mirror = true;
+        this.armLeft.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armLeft.setRotationPoint(5.0F, 2.0F + var2, 0.0F);
+        this.legRight = new Cube(0, 16);
+        this.legRight.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legRight.setRotationPoint(-2.0F, 12.0F + var2, 0.0F);
+        this.legLeft = new Cube(0, 16);
+        this.legLeft.mirror = true;
+        this.legLeft.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legLeft.setRotationPoint(2.0F, 12.0F + var2, 0.0F);
+    }
+
+    @Override
+    public void setupAnimation(@Nullable Mob mob, float limbSwing, float limbYaw, float limbPitch, float headYaw, float headPitch, float scale, float partialTick) {
+        super.setupAnimation(mob, limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale, partialTick);
+        float var7 = MathHelper.sin(this.swingProgress * 3.1415927F);
+        float var8 = MathHelper.sin((1.0F - (1.0F - this.swingProgress) * (1.0F - this.swingProgress)) * 3.1415927F);
+        this.armRight.zRot = 0.0F;
+        this.armLeft.zRot = 0.0F;
+        this.armRight.yRot = -(0.1F - var7 * 0.6F);
+        this.armLeft.yRot = 0.1F - var7 * 0.6F;
+        this.armRight.xRot = -1.5707964F;
+        this.armLeft.xRot = -1.5707964F;
+        this.armRight.xRot -= var7 * 1.2F - var8 * 0.4F;
+        this.armLeft.xRot -= var7 * 1.2F - var8 * 0.4F;
+        this.armRight.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        this.armLeft.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        this.armRight.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        this.armLeft.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index e7d7fdca4..3e6a423ea 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -4,9 +4,9 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.world.WorldSource;
 import org.lwjgl.opengl.GL11;
 
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
@@ -98,13 +98,11 @@ public abstract class ChunkRenderer
     
     public abstract void rebuild();
     
-    public boolean renderBlock(Tessellator tessellator, RenderBlocks renderBlocks, BlockModel<?> model, int x, int y, int z) {
+    public boolean renderBlock(Tessellator tessellator, WorldSource worldSource, BlockModel<?> model, int x, int y, int z) {
     	boolean rendered = false;
-		rendered |= model.render(tessellator, x, y, z);
+		rendered |= model.render(tessellator, worldSource, x, y, z);
 		if(model.hasOverbright()) {
-			renderBlocks.overbright = true;
-			rendered |= model.render(tessellator, x, y, z);
-			renderBlocks.overbright = false;
+			rendered |= model.renderOverbright(tessellator, worldSource, x, y, z);
 		}
 		return rendered;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
index b203a5574..9691b5268 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererLegacy.java
@@ -9,9 +9,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import org.lwjgl.opengl.GL11;
 
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
@@ -42,8 +41,6 @@ public class ChunkRendererLegacy extends ChunkRenderer {
         renderableBlockEntities.clear();
         final int cacheRadius = 1;
         final ChunkCache chunkcache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
-        final RenderBlocks renderblocks = new RenderBlocks(chunkcache);
-        BlockModel.setRenderBlocks(renderblocks);
         int renderPass = 0;
         Tessellator tessellator = Tessellator.instance;
         do
@@ -82,8 +79,8 @@ public class ChunkRendererLegacy extends ChunkRenderer {
                             }
                         }
                         if(renderPass == 0 && Blocks.isEntityTile[blockId]) {
-                            final TileEntity tileentity = chunkcache.getBlockEntity(x, y, z);
-                            if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+                            final TileEntity tileentity = chunkcache.getTileEntity(x, y, z);
+                            if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
                                 renderableBlockEntities.add(tileentity);
                             }
                         }
@@ -98,7 +95,7 @@ public class ChunkRendererLegacy extends ChunkRenderer {
                         		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
                         	}
 
-    						hasRenderedBlock |= renderBlock(tessellator, renderblocks, model, x, y, z);
+    						hasRenderedBlock |= renderBlock(tessellator, world, model, x, y, z);
                         }
                     }
                 }
